#include "SerialPort.H"

extern "C" int read(); //these make it work!!
extern "C" int bzero();


SerialPort::SerialPort() {
	printf("Creating SerialPort object\n");
}

char SerialPort::poll() {
	char yip;
	int fip;
	do{
		fip= read(fileDescriptor,&yip,1);
	}while(fip <0);

	return yip;

}

int SerialPort::openPort() {
	/* Open the serial port */
	fileDescriptor = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK );
	if (fileDescriptor <0) {perror(MODEMDEVICE); exit(-1); }

	tcgetattr(fileDescriptor,&oldtio); /* save current port settings */

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;

	/* set input mode */
	newtio.c_lflag = 0;
	newtio.c_cc[VTIME]    = 100;  /* inter-character timer times out at 0.1 sec */
	newtio.c_cc[VMIN]     = 1;    /* blocking read until 1 chars received */

	tcflush(fileDescriptor,TCIFLUSH);
	tcsetattr(fileDescriptor,TCSANOW,&newtio);

	printf("Beginning read from serial port\n");
}

int SerialPort::closePort() {
	printf("Closing serial port\n");
  	tcsetattr(fileDescriptor,TCSANOW,&oldtio);
}
